create or replace package kc_pck_alg_service as
  type gt_char_array is table of varchar2(200) index by binary_integer;
end;
/ 
show err

create or replace package kc_pck_emp_shuttle as
   procedure to_dept
   ( p_empnos  kc_pck_alg_service.gt_char_array
   , p_deptno  number
   ) ;
   procedure from_dept
   ( p_empnos  kc_pck_alg_service.gt_char_array
   ) ;
end;
/
show err
--
create or replace package body kc_pck_emp_shuttle as
--
procedure update_dept
( p_empno   number
, p_deptno  number
) is
begin
   update emp
   set    deptno = p_Deptno
   where  empno  = p_empno
   ;
end;
--
procedure to_dept
( p_empnos  kc_pck_alg_service.gt_char_array
, p_deptno  number
) is
begin
   for i in 1..p_empnos.count loop
      update_dept
      ( p_empnos(i)
      , p_deptno
      ) ;
   end loop;
   --
   commit;
   --
end;
--
procedure from_dept
( p_empnos  kc_pck_alg_service.gt_char_array
) is
begin
   for i in 1..p_empnos.count loop
      update_dept
      ( p_empnos(i)
      , to_number(null)
      ) ;
   end loop;
   --
   commit;
   --
end;
end;
/
show err

create or replace package kc_dept_service as
--
function dname (p_deptno varchar2) return varchar2;
--
end;
/
create or replace package body kc_dept_service as
--
function dname (p_deptno varchar2) return varchar2 is
   --
   cursor c_dept is
   select dname 
   from   dept
   where  deptno = p_deptno;
   --
   l_dname dept.dname%type;
begin
   open c_dept;
   fetch c_dept into l_dname;
   close c_dept;
   return l_dname;
end;
--
end;
/
create or replace package kc_emp_service as
--
function is_manager_c (p_empno varchar2) return varchar2;
--
function ename (p_empno varchar2) return varchar2;
--
end;
/
create or replace package body kc_emp_service as
--
function is_manager_c (p_empno varchar2) return varchar2 is
   --
   cursor c_emp is
   select 1
   from   emp
   where  mgr = p_empno;
   --
   l_is_manager_c  varchar2(1);
   l_dummy         number(1);
begin
   open c_emp;
   fetch c_emp into l_dummy;
   if c_emp%found then
      l_is_manager_c := 'Y';
   else
      l_is_manager_c := 'N';
   end if;
   close c_emp;
   return l_is_manager_c;
end;
--
function ename (p_empno varchar2) return varchar2 is
   --
   cursor c_emp is
   select ename
   from   emp
   where  empno = p_empno;
   --
   l_ename  emp.ename%type;
begin
   open c_emp;
   fetch c_emp into l_ename;
   close c_emp;
   return l_ename;
end;
--
end;
/
create or replace package kc_emp_mutation as
--
procedure delete_emp (p_empno varchar2);
--
end;
/
create or replace package body kc_emp_mutation as
--
procedure delete_emp (p_empno varchar2) is
   --
begin
   delete emp
   where  empno = p_empno
   ;
   commit;
end;
--
end;
/
